

---------------------------------------------------------------------
--== Main Window ===--
---------------------------------------------------------------------

Options = class( Turbine.UI.Lotro.Window )

function Options:Constructor(left, top, width, height)
	Turbine.UI.Lotro.Window.Constructor( self )
	
	self.width = width
	
	self:SetResizable(true)
	self:SetText("RaidEffects")
	self:SetPosition(left,top)


	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self)
	self.listbox:SetMouseVisible(false)
	
	self.listbox:AddItem(Options_Header(self:GetSize()))
	self.listbox:AddItem(Options_Body(self:GetSize()))
	self.listbox:AddItem(Options_Foot(self:GetSize()))
	
	self:SetMinimumHeight(300)
	self:SetMinimumWidth(self.width)
	self:SetMaximumWidth(self.width)
	self:SetSize(width, height)
	self.listbox:SetSize(self:GetSize())
	
	self:SetVisible(true)
	
end

function Options:Closed( args, sender )
	CloseOptions()
end

function Options:ShowAdvanced(bool)

	if bool then
		self.width  = self.width+450
		self:SetMinimumWidth(self.width)
		self:SetMaximumWidth(self.width)
		self:SetWidth(self.width)
	else
		self.width  = self.width-450
		self:SetMinimumWidth(self.width)
		self:SetMaximumWidth(self.width)
		self:SetWidth(self.width)
	end

end

function Options:SizeChanged(args, sender)
	
	self.width = self:GetWidth()
	
	self.listbox:SetSize(self:GetSize())
	for i=1, self.listbox:GetItemCount(), 1 do
		self.listbox:GetItem(i):Resize(self:GetSize())
	end
	
	CharacterSettings["options"]["height"] =  self:GetHeight()
	
	saveSettings()
end

function Options:UpdateSessionList()
	self.listbox:GetItem(2):UpdateSessionList()
end

function Options:PositionChanged(args, sender)

	CharacterSettings["options"]["left"] =  self:GetLeft()
	CharacterSettings["options"]["top"]	 =	self:GetTop()

	saveSettings()

end

---------------------------------------------------------------------
--== Header ===--
---------------------------------------------------------------------

Options_Header = class(Turbine.UI.Control)

function Options_Header:Constructor(width, height)
	Turbine.UI.Control.Constructor( self )
	self:SetSize(width,50)
	self:SetMouseVisible(false)

end

function Options_Header:Resize(width, height)
	self:SetWidth(width)
end

---------------------------------------------------------------------
--== Body ===--
---------------------------------------------------------------------

Options_Body = class(Turbine.UI.Control)

function Options_Body:Constructor(width, height)
	Turbine.UI.Control.Constructor( self )
	self:SetSize(width,height-80)
	self:SetMouseVisible(false)
	
	self.showAdvanced = false
	self.book = nil

--=== windowSelect ===--

	self.windowLabel = Turbine.UI.Label()
	self.windowLabel:SetParent(self)
	self.windowLabel:SetSize(200, 25)
	self.windowLabel:SetMouseVisible(false)
	self.windowLabel:SetPosition(15,10)
	self.windowLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
	self.windowLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
	self.windowLabel:SetText("windows")
	
	self.windowSelect = LoadSelection(200,height-145)
	self.windowSelect:SetParent(self)
	self.windowSelect:SetPosition(10,55)

--=== effectList ===--	

	self.listLabel = Turbine.UI.Label()
	self.listLabel:SetParent(self)
	self.listLabel:SetSize(160, 25)
	self.listLabel:SetMouseVisible(false)
	self.listLabel:SetPosition(225,10)
	self.listLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
	self.listLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
	self.listLabel:SetText("aktive effects list")

	self.effectList = EffectList(200, height-150, self.book, self.book, Turbine.UI.Color(0.1,0.1,0.1))
	self.effectList:SetParent(self)
	self.effectList:SetPosition(220,30)

--=== sessionList ===--	

	self.sessionLabel = Turbine.UI.Label()
	self.sessionLabel:SetParent(self)
	self.sessionLabel:SetSize(200, 25)
	self.sessionLabel:SetMouseVisible(false)
	self.sessionLabel:SetPosition(435,10)
	self.sessionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
	self.sessionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
	self.sessionLabel:SetText("session only effects")
	
	self.sessionList = EffectList(200, height-145, FoundEffects,self.book,nil)
	self.sessionList:SetParent(self)
	self.sessionList:SetPosition(430,55)
		
--=== libraryList ===--	
	
	self.libraryLabel = Turbine.UI.Label()
	self.libraryLabel:SetParent(self)
	self.libraryLabel:SetSize(200, 25)
	self.libraryLabel:SetMouseVisible(false)
	self.libraryLabel:SetPosition(645,10)
	self.libraryLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
	self.libraryLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
	self.libraryLabel:SetText("effects library")
	
	self.libraryList = EffectList(200, height-120, EffectsLibrary["savedeffects"], nil, self.book)
	self.libraryList:SetParent(self)
	self.libraryList:SetPosition(640,30)
		
--=== optionsPanel ===--	
	
	self.panel = OptionsPanel(390,height-100)
	self.panel:SetParent(self)
	self.panel:SetPosition(850,10)
		
--=== misc ===--	

	self.moveCheck =  Turbine.UI.Lotro.CheckBox()
	self.moveCheck:SetParent(self)
	self.moveCheck:SetSize(200,25)
	self.moveCheck:SetPosition(20,30)
	self.moveCheck:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.moveCheck:SetText(" move windows while checked")
	self.moveCheck:SetChecked(onlySearchDebuffs)
	self.moveCheck.CheckedChanged = function(sender, args)
		MoveWindows(self.moveCheck:IsChecked())
	end

	self.addTextBox = Turbine.UI.Lotro.TextBox()
	self.addTextBox:SetParent(self)
	self.addTextBox:SetSize(158, 25)
	self.addTextBox:SetPosition(220,height-115)
	self.addTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.addTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.addTextBox:SetForeColor(Turbine.UI.Color(0.7,0.7,0.7))
	self.addTextBox:SetText("add effect by name only ...")
	self.addTextBox.FocusGained = function(sender, args)
		self.addTextBox:SetForeColor(Turbine.UI.Color.White)
		if self.addTextBox:GetText() == "add effect by name only ..." then
			self.addTextBox:SetText("")
		end
		
	end
	self.addTextBox.FocusLost = function(sender, args)
		self.addTextBox:SetForeColor(Turbine.UI.Color(0.7,0.7,0.7))
		if self.addTextBox:GetText() == "" then
			self.addTextBox:SetText("add effect by name only ...")
		end
	end
	
	self.addButton =Turbine.UI.Lotro.Button()
	self.addButton:SetParent(self)
	self.addButton:SetPosition(380, height-112)
	self.addButton:SetSize(40,25)
	self.addButton:SetText("add")
	self.addButton:SetEnabled(false)
	self.addButton.MouseClick = function(sender, args)
		local b = {}
		b["name"] = self.addTextBox:GetText()
		b["isdebuff"] = false
		b["icon"] = nil
		 AddPage(self.book, b)
		 
		self.effectList:UpdateLists(self.book, self.book)
		self.libraryList:UpdateLists(EffectsLibrary["savedeffects"], self.book)
		self.addTextBox:SetText("add effect by name only ...")
	end
		
	self.playButton =Turbine.UI.Lotro.Button()
	self.playButton:SetParent(self)
	self.playButton:SetPosition(435, 30)
	self.playButton:SetWidth(55)
	self.playButton:SetText("collect")
	if collectEffects then
		self.playButton:SetEnabled(false)
	else
		self.playButton:SetEnabled(true)
	end
	self.playButton.MouseClick = function(sender, args)
		
		local eList
		local e
		
		for i,x in ipairs(players) do
			eList = x:GetEffects()
			
			for j=1, eList:GetCount(), 1 do
				e = eList:Get(j)
				if onlySearchDebuffs == true and  effect:IsDebuff() == false then 
				else
					checkForCollection(string.lower(e:GetName()), e:GetIcon(), e:IsDebuff())
				end
			end
		end
		
		self.playButton:SetEnabled(false)
		self.stopButton:SetEnabled(true)
		changeCollect(true)
	end
	
	self.stopButton =Turbine.UI.Lotro.Button()
	self.stopButton:SetParent(self)
	self.stopButton:SetPosition(490, 30)
	self.stopButton:SetSize(50,25)
	self.stopButton:SetText("stop")
	if collectEffects then
		self.stopButton:SetEnabled(true)
	else
		self.stopButton:SetEnabled(false)
	end
	self.stopButton.MouseClick = function(sender, args)
		self.stopButton:SetEnabled(false)
		self.playButton:SetEnabled(true)
		changeCollect(false)
	end
	
	self.sessionCheck =  Turbine.UI.Lotro.CheckBox()
	self.sessionCheck:SetParent(self)
	self.sessionCheck:SetSize(120,25)
	self.sessionCheck:SetPosition(545,29)
	self.sessionCheck:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.sessionCheck:SetText(" only debuffs")
	self.sessionCheck:SetChecked(onlySearchDebuffs)
	self.sessionCheck.CheckedChanged = function(sender, args)
		changeSearchDebuffs(self.sessionCheck:IsChecked())
	end
	
	self.advancedOptionsButton =Turbine.UI.Lotro.Button()
	self.advancedOptionsButton:SetParent(self)
	self.advancedOptionsButton:SetPosition(802, 5)
	self.advancedOptionsButton:SetSize(25,25)
	self.advancedOptionsButton:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
	self.advancedOptionsButton:SetText(">")
	self.advancedOptionsButton.MouseClick = function(sender, args)
		if self.showAdvanced then
			self.advancedOptionsButton:SetText(">")
			self.showAdvanced = false
			self:GetParent():GetParent():ShowAdvanced(false)
		else
			self.advancedOptionsButton:SetText("<")
			self.showAdvanced = true
			self:GetParent():GetParent():ShowAdvanced(true)
		end
	end

end

function Options_Body:ActivWindowNameChanged(name)
	self.windowSelect:ActivWindowNameChanged(name)
end

function Options_Body:Deselect()

	self.book = nil
	self.effectList:UpdateLists(self.book, self.book)
	self.sessionList:UpdateLists(FoundEffects, self.book)
	self.libraryList:UpdateLists(EffectsLibrary["savedeffects"], self.book)
	self.panel:FillSelected(nil,nil)
	self.addButton:SetEnabled(false)

end


function Options_Body:EffectStatusChanged(effect, status)

	if self.book ~= nil then	
		if status then
			AddPage(self.book, effect)
		else
			RemovePage(self.book, effect)
		end
		
		self.effectList:UpdateLists(self.book, self.book)
		self.sessionList:UpdateLists(FoundEffects, self.book)
		self.libraryList:UpdateLists(EffectsLibrary["savedeffects"], self.book)
	end
end

function Options_Body:UpdateSessionList()

	self.sessionList:UpdateLists(FoundEffects, self.book)
end

function Options_Body:FillSelected(book, settings)

	self.book = book
	self.effectList:UpdateLists(book, book)
	self.sessionList:UpdateLists(FoundEffects, book)
	self.libraryList:UpdateLists(EffectsLibrary["savedeffects"], book)
	self.panel:FillSelected(book, settings)
	self.addButton:SetEnabled(true)

end

function Options_Body:Resize(width, height)
	self:SetSize(width,height-80)
	self.windowSelect:Resize(height-145)
	self.effectList:Resize(height-150)
	self.sessionList:Resize(height-145)
	self.libraryList:Resize(height-120)
	self.panel:Resize(width-780, height-100)
	self.addButton:SetPosition(380, height-112)
	self.addTextBox:SetPosition(220,height-115)

end



---------------------------------------------------------------------
--== Foot ===--
---------------------------------------------------------------------

Options_Foot = class(Turbine.UI.Control)

function Options_Foot:Constructor(width, height)
	Turbine.UI.Control.Constructor( self )
	self:SetSize(width,40)
	self:SetMouseVisible(false)
	

end

function Options_Foot:Resize(width, height)
	self:SetWidth(width)
end

